C*********************************************************************
C
C     PROGRAM xzcont_w_cl
C
C     x-z平面等値線図作成プログラム(時刻, 条件指定, カラー)
C
C     履歴 1997/07/24 中島健介
C          1997/07/25 小高正嗣
C          1997/07/26 小高正嗣
C          1997/07/26 小高正嗣
C          1998/09/15 小高正嗣
C          1998/10/02 小高正嗣
C          1998/01/10 小高正嗣
C          1998/01/18 小高正嗣
C          1999/01/27 小高正嗣
C          1999/02/04 小高正嗣
C
C*********************************************************************
      program xzcont_u_cl
*-----------------------------------------------------
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------

#include "grid_size_M.f"

      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
*-----------------------------------------------------
      integer ibr(nbr3)
*-----------------------------------------------------
      real cdp                  ! カラートーン刻み
      real tlev1,tlev2          ! カラーレベル
      integer ipat              ! トーン番号
      integer cmax
      parameter ( cmax = 56 )
      real wmax, wmin
      parameter ( wmax = 30., wmin = -30. )

      real*4 pti(2,cmax)
*-----------------------------------------------------
      real*8
     \   zgrid ( -2:nzb ),
     \   temp0 ( -2:nzb ),
     \   tpot0 ( -2:nzb ),
     \   dens0 ( -2:nzb ),
     \   ppai0 ( -2:nzb ),
     \   pres0 ( -2:nzb ),
     \   rvap0 ( -2:nzb ),
     \   qvap0 ( -2:nzb )

      real*8
     \     w ( -2:nxb, -2:nzb )

      real*4
     \    z0p ( 0:nz ), 
     \    p0p ( 0:nz ),
     \    d0p ( 0:nz ),
     \ temp0p ( 0:nz ),
     \ tpot0p ( 0:nz ),
     \  pai0p ( 0:nz ),
     \ rvap0p ( 0:nz ),
     \ qvap0p ( 0:nz )

      real*4 
     \      wp ( nx+1,nz+1 )

      character*6 stime
      character*11 ttime
      character*100 dumy

      character*2 mint
      character*2 hour
      character*2 day
      character*14 header

*-----------------------------------------------------
      
      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu

      call FOPEN ( irun+1 )

      write(day,'(I2.2)') irun

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, zgrid(iz), pres0(iz), dens0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), qvap0(iz), rvap0(iz)
      end do

      do iz = 0, nz
         z0p(iz)   = zgrid(iz)
         p0p(iz)   = pres0(iz)
         d0p(iz)   = dens0(iz)
         temp0p(iz)= temp0(iz)
         tpot0p(iz)= tpot0(iz)
         pai0p(iz) = ppai0(iz)
         rvap0p(iz)= rvap0(iz)
         qvap0p(iz)= qvap0(iz)
      end do

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv

      call sgpwsn
      read(*,*) iws

      CALL SWISET('IWIDTH',  720)
c      CALL SWISET('IHEIGHT', 540)
      CALL SWISET('IHEIGHT', 400)

      call gropn(iws)
      call swlset( 'LALT',  .TRUE. )
      call sglset( 'LFULL', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )
      call uzfact(0.6)

      cdp = (wmax - wmin)/cmax
      do i = 1,cmax
         TLEV2 =  wmin + i*cdp 
         TLEV1 =  TLEV2 - cdp
         ipat  = (30+(i-1))*1000 + 999
         call uestlv(TLEV1, TLEV2, IPAT)
      end do

      do k=1,cmax+1
        pti(1,k) = wmin + (k-1)*cdp
        pti(2,k) = wmin + (k-1)*cdp
      end do

      do it = 1, ite

      read(31) time, ((w(ix,iz),ix=-2,nxb), iz=-2,nzb)

      write(0,*) 'reading time = ', time

      if ( it .ge. itb   .and.  it .le. ite ) then
         if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(0,*) 'writing time = ', time
           
            write(stime,100) INT(time)
 100        format(I6.6)
            ttime = 't='// stime //'sec'

c*** 時刻変換: 秒から LT へ************************************
            time = time - 86400.* ( irun -2 )
            time = time / 3600. + 6

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(hour, '(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

            header =  ' LT=' // hour // ':' // mint
c            header = 'day' // day // ' LT=' // hour // ':00'
c**************************************************************


            do iz = 1,nz+1            
               do ix = 1, nx+1
                  wp(ix,iz)    = w(ix-1,iz-1)
               end do
            end do
*
            call grfrm
            call grfig
            call grswnd ( 0.0, 51.2, 0.0, 20.0 )
            call grsvpt ( 0.1, 0.9, 0.20, 0.512 )
            call grstrn (1)
            call uspfit
            call grstrf
            call udpset ( 'rsizet', 0.01 )
            call ussttl ( 'U[m/s]', 'X[km]', '', 'Z[km]' )

            call uetonf ( wp, nx+1, nx+1, nz+1 )
            call usdaxs
            call uxsttl ( 'T', header, 1. )

C*********************************************************************
C トーンバー
C*********************************************************************
            call grfig
            call grswnd( 0.0, 1.0,  wmin, wmax )
            call grsvpt( 0.95, 0.98,  0.20,  0.512 )
            call grstrn( 1 )
            call grstrf
            call uetone( pti, 2, 2, cmax+1 )

            call slpvpr( 3 )
            call uyaxdv( 'L', 5., 10. )
*
*
         end if
      end if

      end do

      call grcls

      call FCLOSE

      end
